
;Pcspace-screen driver ATI- 256colors
;
;To create a atih.drv:
; tasm atih
; tlink atih
; exe2bin atih
; ren atih.bin atih.drv
;
; Attention: Maximum length of the drv file: 256 Bytes

prog  segment para 'code'
 assume cs:prog
 assume ds:prog
 assume ss:prog
 assume es:prog

start  proc  far
       ; Initialize entry point for video mode
       jmp short init

       ; Set the entry point 64k bank and set the segment address to es
       ; The bank number has been set in al.
       jmp short bank

     ;parameter for the driver
       db 255 ;number of colors-1
       ;Table of parameters for initialization
       db 62h ;Mode 0: resolution 640*480
       db 63h ;Mode 1: resolution 800*600
       db 64h ;Mode 2: resolution 1024*768
       db -1  ;Mode 3: resolution 1280*960 (no such resolution)
       db -1  ;Mode 4: resolution 1280*1024 (no such resolution)

       db "ATI 256colors" ;Identification text for SETUP
       db 0               ;length can be adjustable

     ;Initialize video mode
     ;Used registers: ax,bx
     ;al has been set to the value of the parameter table
     ;No such resolution (Par.-1) has been captured already.
 init: push  bx
       xor   ah,ah
       int   10h

       mov   dx,0c000h
       mov   es,dx
       mov   dx,es:[10h]

  etst:pop   bx
       add   bx,1+offset padr
       mov   cs:bx,dx
       retf


     ;set video bank
     ;Used registers: ax,dx,es
 bank: mov   ah,al
  padr:mov   dx,0ffffh
       in    al,dx
       push  ax

       mov   al,ah
       and   ax,0807h
       sub   ah,8
       cmc
       rcl   al,1

       mov   ah,al
       shl   ah,4
       or    ah,al
       mov   al,0b2h
       out   dx,ax

       pop   ax
       out   dx,al

       ;segmentadr. video memory
       mov   dx,0a000h
       mov   es,dx
       retf


start  endp

prog  ends

 end  start