;From markst@smtplink.chips.com Thu Jan  6 23:48:39 1994
;Pcspace-screen driver C&T450 - 256colors
;
;To create a ct450h.drv:
; tasm ct450h
; tlink ct450h
; exe2bin ct450h
; ren ct450h.bin ct450h.drv
;
; Attention: Maximum length of the drv file: 256 Bytes

prog  segment para 'code'
 assume cs:prog
 assume ds:prog
 assume ss:prog
 assume es:prog

start  proc  far
       ; Initialize entry point for video mode
       jmp short init

       ; Set the entry point 64k bank and set the segment address to es
       ; The bank number has been set in al.
       jmp short bank

     ;parameter for the driver
       db 0ffh ;number of colors-1
       ;Table of parameters for initialization
       db 79h ;Mode 0: resolution 640*480
       db -1  ;Mode 1: resolution 800*600   (no such resolution)
       db -1  ;Mode 2: resolution 1024*768  (no such resolution)
       db -1  ;Mode 3: resolution 1280*960  (no such resolution)
       db -1  ;Mode 4: resolution 1280*1024 (no such resolution)

       db "C&T-450 256colors" ;Identification text for SETUP
       db 0                   ;length can be adjustable

     ;Initialize video mode
     ;Used registers: ax,bx
     ;al has been set to the value of the parameter table
     ;No such resolution (Par.-1) has been captured already.
 init: xor   ah,ah
       int   10h
       mov   dx,46e8h
       mov   al,18h
       out   dx,al
       mov   dx,103h
       mov   al,0c0h
       out   dx,al
       mov   dx,46e8h
       mov   al,8h
       out   dx,al
       retf


     ;set video bank
     ;Used registers: ax,dx,es
 bank: mov   ah,al
       shl   ah,4
       mov   al,10h

       mov   dx,03b6h
       out   dx,ax

       ;segmentadr. video memory
       mov   dx,0a000h
       mov   es,dx
       retf


start  endp

prog  ends

 end  start